/****************************************************************************
 *	Copylight(C) 2018 Kanazawa-soft-design,LLC.
 ****************************************************************************/
/*!
 *	@file	FileDataView.cpp
 *
 *	@brief	t@C̓eoCi\r[.
 *
 *	@author	V 閾
 */
#include "stdafx.h"
#include "MFCApp001.h"
#include "FileDataView.h"
#include "MFCApp001Doc.h"

IMPLEMENT_DYNCREATE(CFileDataView, CView)

BEGIN_MESSAGE_MAP(CFileDataView, CView)
	ON_WM_VSCROLL()
	ON_WM_HSCROLL()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEWHEEL()
	ON_WM_SIZE()
END_MESSAGE_MAP()

/****************************************************************************/
/*!
 *	@brief	RXgN^.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
CFileDataView::CFileDataView()
{
}

/****************************************************************************/
/*!
 *	@brief	fXgN^.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
CFileDataView::~CFileDataView()
{
}

/****************************************************************************/
/*!
 *	@brief	r[𐶐.
 *
 *	@param	[in]	lpszClassName	EChENX̃|C^.
 *	@param	[in]	lpszWindowName	EChE̕\̃|C^.
 *	@param	[in]	dwStyle			EChEX^C.
 *	@param	[in]	rect			EChẼTCY.
 *	@param	[in]	pParentWnd		eEChẼIuWFNg.
 *	@param	[in]	nID				EChEID.
 *	@param	[in]	pContext		CCreateContext\̂̃|C^.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
BOOL CFileDataView::Create( LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, 
								const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext )
{
	//! EChEɃXN[o[\.
	dwStyle |= WS_VSCROLL;
	dwStyle |= WS_HSCROLL;

	//! XN[o[̃bp[NXɃEChERÂ.
	m_ScrollV.Bind( this, SB_VERT );
	m_ScrollH.Bind( this, SB_HORZ );

	//! ŌɊNX̃\bhĂяo.
	return CView::Create( lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext );
}

/****************************************************************************/
/*!
 *	@brief	\NA.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	CFileDataView::Clear( void )
{
	//! XN[o[̂܂݈ʒuNA.
	m_ScrollV.Action( SB_TOP );
	m_ScrollH.Action( SB_TOP );

	//! t@CTCYɍ킹ăXN[o[ݒ肷.
	SetScrollBar();
}

/****************************************************************************/
/*!
 *	@brief	EChE̕`Cxg.
 *
 *	@param	[in]	pDC		foCXReLXg.
 *
 *	@retval	Ȃ.
 */
void CFileDataView::OnDraw( CDC* pDC )
{
	//! EChẼNCAg̈̃TCY擾.
	CRect area;
	GetClientRect( &area );

	//! zfoCXReLXg쐬.
	CDC memDC;
	memDC.CreateCompatibleDC( pDC );

	//! zfoCXReLXgɃrbg}bvݒ肷.
	CBitmap memBmp;
	memBmp.CreateCompatibleBitmap( pDC, area.Width(), area.Height() );
	CBitmap* def_bitmap = memDC.SelectObject( &memBmp );

	//! tHg쐬ĕ`ɎgptHgւ.
	CFont font;
	if( !CreateFont( font ) ){
		return;
	}
	CFont* def_font = memDC.SelectObject( &font );

	//! wiNA(rbg}bvwiFœhԂ).
	CBrush white( RGB( 255, 255, 255 ) );
	memDC.FillRect( &area, &white );

	//! zfoCXReLXgɑ΂ĉʂ̕`s.
	DrawMain( &memDC, area );

	//! zfoCXReLXg̃rbg}bv`悷.
	BitBlt( pDC->GetSafeHdc(), 0, 0, area.Width(), area.Height(), memDC.GetSafeHdc(), 0, 0, SRCCOPY );

	//! ւtHgɖ߂āA쐬tHgj.
	memDC.SelectObject( def_font );
	font.DeleteObject();

	//! zfoCXReLXg̃rbg}bvɖ߂āA쐬rbg}bvj.
	memDC.SelectObject( def_bitmap );
	memBmp.DeleteObject();

	//! zfoCXReLXgj.
	memDC.DeleteDC();
}

/****************************************************************************/
/*!
 *	@brief	`揈̃C.
 *
 *	@param	[in]	pDC		foCXReLXg.
 *	@param	[in]	area	EChẼNCAg̈̃TCY.
 *
 *	@retval	Ȃ.
 */
void CFileDataView::DrawMain( CDC* pDC, CRect& area )
{
	//! tHg̍ƕ擾.
	TEXTMETRIC tm;
	pDC->GetTextMetrics( &tm );
	int fontH = tm.tmHeight + tm.tmExternalLeading;
	int fontW = tm.tmAveCharWidth;

	CMFCApp001Doc* pDoc = dynamic_cast<CMFCApp001Doc*>( GetDocument() );

	//! t@C̓eƃoCg擾.
	BYTE* buf  = pDoc->GetFileBuffer();
	DWORD size = pDoc->GetFileSize();
	if( buf == NULL || size == 0 ){
		return;
	}
	//! XP[`悷.
	DrawScale( pDC, area, fontH, fontW );

	//! 1ʂɕ\\ȍsZo.
	int lines = (fontH > 0) ? (area.Height() + (fontH - 1)) / fontH : 1;

	//! t@Cf[^oCi`ŕ`悷.
	DWORD adr = m_ScrollV.GetPos() * 16;
	for( int i = 1; i <= lines; i++ ){
		if( adr >= size ){
			break;
		}
		//! 1s̃oCif[^`悷.
		DrawBinaryData( pDC, buf, size, i, fontH, fontW, adr );
		adr += 16;
	}
}

/****************************************************************************/
/*!
 *	@brief	XP[`悷.
 *
 *	@param	[in]	pDC		foCXReLXg.
 *	@param	[in]	area	EChẼNCAg̈̃TCY.
 *	@param	[in]	fontH	tHg̍.
 *	@param	[in]	fontW	tHg̕.
 *
 *	@retval	Ȃ.
 */
void CFileDataView::DrawScale( CDC* pDC, CRect& area, int fontH, int fontW )
{
	CRect rc1( area );
	rc1.bottom = fontH;

	CBrush bkCol( RGB( 128, 128, 128 ) );
	pDC->FillRect( &rc1, &bkCol );

	int x = -(m_ScrollH.GetPos()) * fontW;

	/// AhX`悷̈hԂ.
	CRect rc2( area );
	rc2.right = rc2.left + (9 * fontW);
	rc2.MoveToX( x );
	pDC->FillRect( &rc2, &bkCol );

	pDC->SetTextColor( RGB( 255, 255, 255 ) );
	pDC->SetBkColor(   RGB( 128, 128, 128 ) );

	/// XP[`悷.
	pDC->TextOut( x               , 0, CString(_T("ADDRESS:")) );
	pDC->TextOut( x + (10 * fontW), 0, CString(_T("+0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F")) );
	pDC->TextOut( x + (58 * fontW), 0, CString(_T("ASCII")) );
}

/****************************************************************************/
/*!
 *	@brief	1s̃oCif[^`悷.
 *
 *	@param	[in]	pDC		foCXReLXg.
 *	@param	[in]	buf		t@Cobt@̃|C^.
 *	@param	[in]	size	t@Cobt@̃TCY.
 *	@param	[in]	line	`Jnsʒu.
 *	@param	[in]	fontH	tHg̍.
 *	@param	[in]	fontW	tHg̕.
 *	@param	[in]	adr		`JnoCif[^̃AhX.
 *
 *	@retval	Ȃ.
 */
void CFileDataView::DrawBinaryData( CDC* pDC, BYTE* buf, DWORD size, int line, int fontH, int fontW, DWORD adr )
{
	int x = -(m_ScrollH.GetPos()) * fontW;
	int y = fontH * line;

	//! ItZbgAhX\.
	CString address;
	address.Format( _T("%08X "), adr );
	pDC->SetTextColor( RGB( 255, 255, 255 ) );
	pDC->SetBkColor(   RGB( 128, 128, 128 ) );
	pDC->TextOut( x, y, address );

	//! oCif[^̕FƔwiFݒ肷.
	pDC->SetTextColor( RGB(   0,   0,   0 ) );
	pDC->SetBkColor(   RGB( 255, 255, 255 ) );

	CString bin,ascii;
	for( int i = 0; i < 16; i++ ){
		//! t@Cf[^Ȃ珈I.
		if( adr >= size ){
			break;
		}
		TCHAR c = buf[adr];

		//! t@Cf[^16iŕ\.
		bin.Format( _T("%02X"), c );
		pDC->TextOut( x + ((10 + (i * 3)) * fontW), y, bin );

		//! t@Cf[^ASCIIf[^Œ߂Ă.
		if( c < _T(' ') || c >= 0x80 ){
			c = _T('.');
		}
		ascii += c;

		adr++;
	}
	//! ŌASCIIf[^\.
	pDC->TextOut( x + (58 * fontW), y, ascii );
}

/****************************************************************************/
/*!
 *	@brief	tHg쐬.
 *
 *	@param	[in]	font	tHgIuWFNg.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
BOOL CFileDataView::CreateFont( CFont& font )
{
	LOGFONT lf;
	memset( &lf, 0, sizeof(LOGFONT) );
	lf.lfHeight         = 16;
	lf.lfWeight         = FW_DONTCARE;
	lf.lfCharSet        = DEFAULT_CHARSET;
	lf.lfPitchAndFamily = FIXED_PITCH | FF_DONTCARE;
	_tcscpy_s( lf.lfFaceName, LF_FACESIZE, _T("lr SVbN") );

	return font.CreateFontIndirect( &lf );
}

/****************************************************************************/
/*!
 *	@brief	XN[o[ݒ肷.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void CFileDataView::SetScrollBar( void )
{
	CDC* pDC = GetDC();

	//! tHg쐬ĕ`ɎgptHgւ.
	CFont font;
	if( !CreateFont( font ) ){
		return;
	}
	CFont* def_font = pDC->SelectObject( &font );

	//! tHg̍ƕ擾.
	TEXTMETRIC tm;
	pDC->GetTextMetrics( &tm );
	int fontH = tm.tmHeight + tm.tmExternalLeading;
	int fontW = tm.tmAveCharWidth;

	if( fontH > 0 && fontW > 0 ){
		//! t@C̃oCg擾.
		CMFCApp001Doc* pDoc = dynamic_cast<CMFCApp001Doc*>( GetDocument() );
		DWORD          size = pDoc->GetFileSize();

		//! EChẼNCAg̈̃TCY擾.
		RECT area;
		GetClientRect( &area );

		//! cXN[o[ݒ肷.
		int height = (area.bottom - area.top) / fontH;
		m_ScrollV.SetScrollBar( (size / 16) + (height >> 1), height, m_ScrollV.GetPos(), 2 );

		//! XN[o[ݒ肷.
		int width = (area.right - area.left) / fontW;
		m_ScrollH.SetScrollBar( 74 + (width >> 1), width, m_ScrollH.GetPos(), 2 );
	}
	//! ւtHgɖ߂āA쐬tHgj.
	pDC->SelectObject( def_font );
	font.DeleteObject();
}

/****************************************************************************/
/*!
 *	@brief	XN[o[̑Cxg (WM_VSCROLL).
 *
 *	@param	[in]	nSBCode		XN[o[̓.
 *	@param	[in]	nPos		XN[{bNẌʒu.
 *	@param	[in]	pScrollBar	XN[o[Rg[̃|C^.
 *
 *	@retval	Ȃ.
 */
void CFileDataView::OnVScroll( UINT nSBCode, UINT nPos, CScrollBar* pScrollBar )
{
	//! XN[o[̂܂݈ʒuύXꂽꍇAEChEĕ`悷.
	if( m_ScrollV.Action( nSBCode ) ){
		InvalidateRect( NULL, FALSE );
	}
	//! ŌɊNX̃\bhĂяo.
	CView::OnVScroll( nSBCode, nPos, pScrollBar );
}

/****************************************************************************/
/*!
 *	@brief	XN[o[̑Cxg (WM_HSCROLL).
 *
 *	@param	[in]	nSBCode		XN[o[̓.
 *	@param	[in]	nPos		XN[{bNẌʒu.
 *	@param	[in]	pScrollBar	XN[o[Rg[̃|C^.
 *
 *	@retval	Ȃ.
 */
void CFileDataView::OnHScroll( UINT nSBCode, UINT nPos, CScrollBar* pScrollBar )
{
	//! XN[o[̂܂݈ʒuύXꂽꍇAEChEĕ`悷.
	if( m_ScrollH.Action( nSBCode ) ){
		InvalidateRect( NULL, FALSE );
	}
	//! ŌɊNX̃\bhĂяo.
	CView::OnHScroll( nSBCode, nPos, pScrollBar );
}

/****************************************************************************/
/*!
 *	@brief	}EX̍{^Ƃ̑Cxg (WM_LBUTTONDOWN).
 *
 *	@param	[in]	nFlags		ĂL[.
 *	@param	[in]	point		}EXJ[\̍W.
 *
 *	@retval	Ȃ.
 */
void CFileDataView::OnLButtonDown( UINT nFlags, CPoint point )
{
	//! tH[JX̃EChEɃZbg.
	SetFocus();

	//! ŌɊNX̃\bhĂяo.
	CView::OnLButtonDown( nFlags, point );
}

/****************************************************************************/
/*!
 *	@brief	}EXzC[̑Cxg (WM_MOUSEHWHEEL).
 *
 *	@param	[in]	nFlags		ĂL[.
 *	@param	[in]	zDelta		}EXzC[̉].
 *	@param	[in]	pt			}EXJ[\̍W.
 *
 *	@retval	Ȃ.
 */
BOOL CFileDataView::OnMouseWheel( UINT nFlags, short zDelta, CPoint pt )
{
	//! }EXzC[̉]XN[o[̑Cxg߂.
	WPARAM up_down = (zDelta < 0) ? SB_LINEDOWN : SB_LINEUP;

	//! XN[o[̑Cxg𔭐.
	SendMessage( WM_VSCROLL, up_down, 0 );

	//! ŌɊNX̃\bhĂяo.
	return CView::OnMouseWheel( nFlags, zDelta, pt );
}

/****************************************************************************/
/*!
 *	@brief	EChETCYύXꂽƂ̃Cxg (WM_SIZE).
 *
 *	@param	[in]	nType		TCYύX̎.
 *	@param	[in]	cx			NCAg̈̐V.
 *	@param	[in]	cy			NCAg̈̐V.
 *
 *	@retval	Ȃ.
 */
void CFileDataView::OnSize( UINT nType, int cx, int cy )
{
	//! ŏɊNX̃\bhĂяo.
	CView::OnSize( nType, cx, cy );

	//! EChEŏƂ͉Ȃ.
	if( nType == SIZE_MINIMIZED ){
		return;
	}
	//! XN[o[XV.
	SetScrollBar();
}

/****************************************************************************/
// CFileDataView ff
#ifdef _DEBUG
void CFileDataView::AssertValid() const
{
	CView::AssertValid();
}

#ifndef _WIN32_WCE
void CFileDataView::Dump( CDumpContext& dc ) const
{
	CView::Dump( dc );
}
#endif
#endif //_DEBUG

/* End of file */
