/****************************************************************************
 *	Copylight(C) 2018 Kanazawa-soft-design,LLC.
 ****************************************************************************/
/*!
 *	@file	FileListView.cpp
 *
 *	@brief	t@Cꗗ\r[.
 *
 *	@author	V 閾
 */
#include "stdafx.h"
#include "MFCApp001.h"
#include "FileListView.h"
#include "MFCApp001Doc.h"
#include "MainFrm.h"


IMPLEMENT_DYNCREATE(CFileListView, CListView)

BEGIN_MESSAGE_MAP(CFileListView, CListView)
	ON_NOTIFY_REFLECT(NM_DBLCLK, &CFileListView::OnNMDblclk)
END_MESSAGE_MAP()

/****************************************************************************/
/*!
 *	@brief	RXgN^.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
CFileListView::CFileListView()
{

}

/****************************************************************************/
/*!
 *	@brief	fXgN^.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
CFileListView::~CFileListView()
{
}

/****************************************************************************/
/*!
 *	@brief	t@Cꗗ̃r[𐶐.
 *
 *	@param	[in]	lpszClassName	EChENX̃|C^.
 *	@param	[in]	lpszWindowName	EChE̕\̃|C^.
 *	@param	[in]	dwStyle			EChEX^C.
 *	@param	[in]	rect			EChẼTCY.
 *	@param	[in]	pParentWnd		eEChẼIuWFNg.
 *	@param	[in]	nID				EChEID.
 *	@param	[in]	pContext		CCreateContext\̂̃|C^.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
BOOL CFileListView::Create( LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle,
								const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext )
{
	//! Xg̕\`uڍ׃Xgvɂ.
	dwStyle |= LVS_REPORT;

	//! ŌɊ{NX̃\bhĂяo.
	return CListView::Create( lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext );
}

/****************************************************************************/
/*!
 *	@brief	t@Cꗗ̃r[.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void CFileListView::OnInitialUpdate()
{
	//! ŏɊ{NX̃\bhĂяo.
	CListView::OnInitialUpdate();

	CListCtrl& listCtrl = GetListCtrl();

	//! Xg̃Jݒ肷.
	LVCOLUMN lvcol;
	lvcol.mask     = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	lvcol.cx       = 250;
	lvcol.pszText  = _T("t@C");
	lvcol.iSubItem = 0;
	lvcol.fmt      = LVCFMT_LEFT;
	listCtrl.InsertColumn( 0, &lvcol );

	lvcol.cx       = 100;
	lvcol.pszText  = _T("TCY");
	lvcol.iSubItem = 1;
	lvcol.fmt      = LVCFMT_RIGHT;
	listCtrl.InsertColumn( 1, &lvcol );

	lvcol.cx       = 150;
	lvcol.pszText  = _T("XV");
	lvcol.iSubItem = 2;
	lvcol.fmt      = LVCFMT_LEFT;
	listCtrl.InsertColumn( 2, &lvcol );
}

/****************************************************************************/
/*!
 *	@brief	t@CꗗXV.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void CFileListView::UpdateFileList()
{
	//! hLgNX̃IuWFNg擾.
	CMFCApp001Doc* pDoc = dynamic_cast<CMFCApp001Doc*>( GetDocument() );
	if( pDoc == NULL ){
		return;
	}
	CListCtrl& listCtrl = GetListCtrl();

	//! Xgr[̓eUNA.
	listCtrl.DeleteAllItems();

	for( int i = 0; i < pDoc->GetFileInfoCount(); i++ ){
		CFileInfo* info = pDoc->GetFileInfo( i );
		if( info == NULL ){
			continue;
		}

		//! Xgr[Ƀt@CZbg.
		LVITEM lvi;
		memset( &lvi, 0, sizeof( lvi ) );

		//! - t@CZbg.
		lvi.mask     = LVIF_TEXT | LVIF_PARAM;
		lvi.iItem    = i;
		lvi.iSubItem = 0;
		lvi.pszText  = info->GetFileName().GetBuffer();
		lvi.lParam   = i;
		listCtrl.InsertItem( &lvi );

		//! - t@CTCYZbg.
		lvi.mask     = LVIF_TEXT;			//! LVIF_PARAMtĂƕ\Ȃ̂ŊO.
		lvi.iSubItem = 1;
		lvi.pszText  = info->GetFileSize().GetBuffer();
		listCtrl.SetItem( &lvi );

		//! - XVZbg.
		lvi.iSubItem = 2;
		lvi.pszText  = info->GetFileDate().GetBuffer();
		listCtrl.SetItem( &lvi );
	}
}

/****************************************************************************/
/*!
 *	@brief	t@Cꗗ̍ڂ_uNbNꂽƂ̑Cxg (NM_DBLCLK).
 *
 *	@param	[in]	pNMHDR		ʒmbZ[W(NMHDR)\̂̃|C^.
 *	@param	[out]	pResult		߂li[̈̃|C^.
 *
 *	@retval	Ȃ.
 */
void CFileListView::OnNMDblclk( NMHDR *pNMHDR, LRESULT *pResult )
{
	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);

	*pResult = 0;

	CListCtrl& listCtrl = GetListCtrl();

	//! hLgNX̃IuWFNg擾.
	CMFCApp001Doc* pDoc = dynamic_cast<CMFCApp001Doc*>( GetDocument() );
	if( pDoc == NULL ){
		return;
	}
	//! NbNꂽڂ̃CfbNX擾.
	int idx = listCtrl.GetNextItem( -1, LVNI_SELECTED );
	if( idx < 0 ){
		return;
	}

	//! Yt@CXg̔ԍo.
	LVITEM lvi;
	memset( &lvi, 0, sizeof( lvi ) );
	lvi.mask  = LVIF_PARAM;
	lvi.iItem = idx;
	listCtrl.GetItem( &lvi );
	int sel_index = lvi.lParam;

	//! NbNꂽt@C̐΃pX擾.
	CString filename = pDoc->GetFilePath( sel_index );

	if( pDoc->IsFile( sel_index ) ){
		//! t@C̏ꍇ͓eoCi`ŕ\.
		pDoc->ShowFile( filename );

		//! Xe[^Xo[Ƀt@C\.
		CMainFrame* frame = dynamic_cast<CMainFrame*>( GetParentFrame() );
		if( frame ){
			frame->StatusMessage( filename );
		}
	}else{
		//! fBNg̏ꍇ̓TufBNgWJ.
		pDoc->ExpandDirectory( filename );
	}
}

/****************************************************************************/
// CFileListView ff
#ifdef _DEBUG
void CFileListView::AssertValid() const
{
	CListView::AssertValid();
}

#ifndef _WIN32_WCE
void CFileListView::Dump( CDumpContext& dc ) const
{
	CListView::Dump( dc );
}
#endif
#endif //_DEBUG

/* End of file */
