/****************************************************************************
 *	Copylight(C) 2018 Kanazawa-soft-design,LLC.
 ****************************************************************************/
/*!
 *	@file	FileTreeView.cpp
 *
 *	@brief	fBNgc[\r[.
 *
 *	@author	V 閾
 */
#include "stdafx.h"
#include "MFCApp001.h"
#include "FileTreeView.h"
#include "MFCApp001Doc.h"

IMPLEMENT_DYNCREATE(CFileTreeView, CTreeView)

BEGIN_MESSAGE_MAP(CFileTreeView, CTreeView)
	ON_NOTIFY_REFLECT(TVN_ITEMEXPANDED, &CFileTreeView::OnTvnItemexpanded)
	ON_NOTIFY_REFLECT(TVN_SELCHANGED, &CFileTreeView::OnTvnSelchanged)
END_MESSAGE_MAP()


/****************************************************************************/
/*!
 *	@brief	RXgN^.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
CFileTreeView::CFileTreeView()
{
}

/****************************************************************************/
/*!
 *	@brief	fXgN^.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
CFileTreeView::~CFileTreeView()
{
}

/****************************************************************************/
/*!
 *	@brief	fBNgc[r[𐶐.
 *
 *	@param	[in]	lpszClassName	EChENX̃|C^.
 *	@param	[in]	lpszWindowName	EChE̕\̃|C^.
 *	@param	[in]	dwStyle			EChEX^C.
 *	@param	[in]	rect			EChẼTCY.
 *	@param	[in]	pParentWnd		eEChẼIuWFNg.
 *	@param	[in]	nID				EChEID.
 *	@param	[in]	pContext		CCreateContext\̂̃|C^.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
BOOL CFileTreeView::Create( LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle,
									const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext )
{
	//! c[Rg[ɃACeԂ̐+-{^\.
	dwStyle |= TVS_HASLINES;
	dwStyle |= TVS_HASBUTTONS;

	//! ŌɊ{NX̃\bhĂяo.
	return CTreeView::Create( lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext );
}

/****************************************************************************/
/*!
 *	@brief	fBNgc[r[.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void CFileTreeView::OnInitialUpdate()
{
	//! ŏɊ{NX̃\bhĂяo.
	CTreeView::OnInitialUpdate();

	CTreeCtrl& treeCtrl = GetTreeCtrl();

	//! Rs[^c[̃[gm[hɃZbg.
	HTREEITEM hRoot = AddRootNode( treeCtrl );
	if( hRoot == NULL ){
		return;
	}
	//! hCuc[ɓo^.
	AddDriveName( treeCtrl, hRoot );

	//! [gm[hWJĕ\.
	treeCtrl.Expand( hRoot, TVE_EXPAND );
}

/****************************************************************************/
/*!
 *	@brief	Rs[^c[̃[gm[hɃZbg.
 *
 *	@param	[in]	treeCtrl	c[r[̃IuWFNg.
 *
 *	@retval	[gm[h.
 */
HTREEITEM CFileTreeView::AddRootNode( CTreeCtrl& treeCtrl )
{
	//! Rs[^擾.
	TCHAR   buf[MAX_COMPUTERNAME_LENGTH+1] = {'\0'};
	DWORD   size = sizeof( buf ) / sizeof( TCHAR );
	LPCTSTR ptr  = buf;
	if( !::GetComputerName( buf, &size ) ){
		ptr = _T("My Computer");
	}
	//! Rs[^c[̃[gm[hɃZbg.
	HTREEITEM hRoot = treeCtrl.InsertItem( ptr, TVI_ROOT );
	return hRoot;
}

/****************************************************************************/
/*!
 *	@brief	fBNgc[ɃhCuo^.
 *
 *	@param	[in]	treeCtrl	c[r[̃IuWFNg.
 *	@param	[in]	hParent		hCuo^m[h.
 *
 *	@retval	Ȃ.
 */
void CFileTreeView::AddDriveName( CTreeCtrl& treeCtrl, HTREEITEM hParent )
{
	//! LȃhCu̕擾.
	TCHAR buf[128] = {'\0'};
	DWORD size     = sizeof( buf ) / sizeof( TCHAR );
	::GetLogicalDriveStrings( size - 1, buf );

	for( LPTSTR ptr = buf ; *ptr != _T('\0') ; ){

		//! hCu񂩂obNXbV('\')菜.
		CString path = ptr;
		path.Remove( _T('\\') );

		//! hCum[hƂăc[ɓo^.
		HTREEITEM hDrv = treeCtrl.InsertItem( path, hParent );

		//! hCũfBNg݂邩𒲂ׂ.
		AddDirectory( treeCtrl, hDrv, path, TRUE );

		//! ( + NULL)ǂݔ΂Ď̐̕擪ֈړ.
		ptr += (_tcslen( ptr ) + 1);
	}
}

/****************************************************************************/
/*!
 *	@brief	fBNgc[ɃfBNgo^.
 *
 *	@param	[in]	treeCtrl	c[r[̃IuWFNg.
 *	@param	[in]	hParent		fBNgo^m[h.
 *	@param	[in]	path		Ym[hɑΉ΃pX̃fBNg.
 *	@param	[in]	isDummy		TRUE = TufBNg݂邩ǂׂ.
 *
 *	@retval	Ȃ.
 */
void CFileTreeView::AddDirectory( CTreeCtrl& treeCtrl, HTREEITEM hParent, CString path, BOOL isDummy )
{
	WIN32_FIND_DATA ffd;
	memset( &ffd, 0, sizeof(WIN32_FIND_DATA) );

	//! ChJ[hu*.*vŃfBNg̑St@Co.
	CString buf = path;
	buf += _T("\\*.*");

	//! w肳ꂽfBNg̃t@CXg擾.
	HANDLE sch = ::FindFirstFile( (LPCTSTR)buf, &ffd );
	if( sch != INVALID_HANDLE_VALUE ){
		/*!
		 * JgfBNg̉ɂfBNĝݒo.
		 * AABfBNgƃJgfBNg( "." ) ̓XgɊ܂߂Ȃ.
		 */
		do{
			if(  ( ffd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )
			&&  !( ffd.dwFileAttributes & FILE_ATTRIBUTE_HIDDEN    )
			&&   ( _tcscmp( ffd.cFileName, _T(".")  ) != 0         )
			&&   ( _tcscmp( ffd.cFileName, _T("..") ) != 0         )){

				//! TufBNgǉ.
				HTREEITEM hItem = treeCtrl.InsertItem( ffd.cFileName, hParent );

				//! TufBNg̑݃`FbN̏ꍇ́A1o_ŏI.
				if( isDummy ){
					return;
				}
				//! TufBNg̑݃`FbNs.
				CString newPath = path;
				newPath += _T("\\");
				newPath += ffd.cFileName;
				AddDirectory( treeCtrl, hItem, newPath, TRUE );
			}
			memset( &ffd, 0, sizeof(WIN32_FIND_DATA) );

		}while( ::FindNextFile( sch, &ffd ) ) ;
	}
}

/****************************************************************************/
/*!
 *	@brief	fBNgc[̃fBNgWJƂ̃Cxg.
 *
 *	@param	[in]	pNMHDR		ʒmbZ[W(NMHDR)\̂̃|C^.
 *	@param	[out]	pResult		߂li[̈̃|C^.
 *
 *	@retval	Ȃ.
 */
void CFileTreeView::OnTvnItemexpanded( NMHDR *pNMHDR, LRESULT *pResult )
{
	LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);

	if( pNMTreeView->action & TVE_EXPAND ){
		HTREEITEM hItem = pNMTreeView->itemNew.hItem;

		CTreeCtrl& treeCtrl = GetTreeCtrl();

		//! WJfBNg̃TufBNgUNA.
		DeleteChildItems( treeCtrl, hItem );

		CString path = GetAbsolutePath( treeCtrl, hItem );
		if( path.GetLength() > 0 ){
			//! WJfBNg̃TufBNg\.
			AddDirectory( treeCtrl, hItem, path, FALSE );
		}else{
			//! tpXꍇ̓[g̓WJȂ̂ŃhCu\.
			AddDriveName( treeCtrl, hItem );
		}
	}
	*pResult = 0;
}

/****************************************************************************/
/*!
 *	@brief	fBNgc[̃fBNg̑IύXƂ̃Cxg.
 *
 *	@param	[in]	pNMHDR		ʒmbZ[W(NMHDR)\̂̃|C^.
 *	@param	[out]	pResult		߂li[̈̃|C^.
 *
 *	@retval	Ȃ.
 */
void CFileTreeView::OnTvnSelchanged( NMHDR *pNMHDR, LRESULT *pResult )
{
	LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);

	CMFCApp001Doc* pDoc = dynamic_cast<CMFCApp001Doc*>( GetDocument() );
	if( pDoc != NULL ){

		//! Iꂽm[hɊYfBNgo.
		CTreeCtrl& treeCtrl = GetTreeCtrl();
		CString path = GetAbsolutePath( treeCtrl, pNMTreeView->itemNew.hItem );

		//! hLgɑIꂽfBNgʒm.
		pDoc->UpdateFileList( path );
	}
	*pResult = 0;
}

/****************************************************************************/
/*!
 *	@brief	w肳ꂽm[hɊYfBNg̐΃pX擾.
 *
 *	@param	[in]	treeCtrl	c[r[̃IuWFNg.
 *	@param	[in]	hItem		efBNg.
 *
 *	@retval	Ȃ.
 */
CString CFileTreeView::GetAbsolutePath( CTreeCtrl& treeCtrl, HTREEITEM hItem )
{
	CString path = _T("");

	//! em[h̃nh擾.
	HTREEITEM hParent = treeCtrl.GetParentItem( hItem );

	/*!
	 * em[hꍇ̓[gm[hȂ̂ŃfBNg͕ԂȂ.
	 * ([gm[h̓Rs[^ɂ)
	 */
	if( !hParent ){
		return path;
	}
	/*!
	 * em[ĥŁAem[h܂ł̃tpX̃fBNg
	 * 擾.
	 */
	path = GetAbsolutePath( treeCtrl, hParent );
	if( path.GetLength() > 0 ){
		path += '\\';
	}
	//! m[h̃fBNg擾āAem[h̃fBNgƘA.
	CString name = treeCtrl.GetItemText( hItem );
	path += name;

	return path;
}

/****************************************************************************/
/*!
 *	@brief	w肳ꂽm[h̎qm[h폜.
 *
 *	@param	[in]	treeCtrl	c[r[̃IuWFNg.
 *	@param	[in]	hItem		qm[h폜m[h.
 *
 *	@retval	Ȃ.
 */
void CFileTreeView::DeleteChildItems( CTreeCtrl& treeCtrl, HTREEITEM hItem )
{
	if( treeCtrl.ItemHasChildren( hItem ) ){

		HTREEITEM hChild = treeCtrl.GetChildItem( hItem );
		while( hChild != NULL ){
			HTREEITEM hNext = treeCtrl.GetNextItem( hChild, TVGN_NEXT );

			treeCtrl.DeleteItem( hChild );

			hChild = hNext;
		}
	}
}

/****************************************************************************/
/*!
 *	@brief	w肳ꂽfBNg̃m[h܂łWJ\.
 *
 *	@param	[in]	path	fBNg̐΃pX.
 *
 *	@retval	Ȃ.
 */
void CFileTreeView::ExpandAndSelectDirectory( CString& path )
{
	CTreeCtrl& treeCtrl = GetTreeCtrl();

	HTREEITEM hItem = treeCtrl.GetRootItem();

	//! Find()ōŌ܂Ō悤ɃpX̍ŌɌt.
	CString wkPath = path + _T("\\");

	int next;
	int pos = 0;
	while( hItem && (next = wkPath.Find( '\\', pos )) != -1 ){

		//! qm[hꍇ͏I.
		if( !treeCtrl.ItemHasChildren( hItem ) ){
			hItem = NULL;
			break;
		}
		//! "\"AĂꍇ͓ǂݔ΂.
		if( next == pos ){
			pos = next + 1;
			continue;
		}
		//! fBNg΃pXo.
		CString dirName = wkPath.Mid( pos, (next - pos) );
		pos = next + 1;

		hItem = treeCtrl.GetChildItem( hItem );
		while( hItem != NULL ){
			//! m[h̃fBNgo.
			CString nodeName = treeCtrl.GetItemText( hItem );

			//! fBNg̃m[h烋[v𔲂.
			if( dirName.CompareNoCase( nodeName ) == 0 ){
				UINT state = treeCtrl.GetItemState( hItem, TVIS_EXPANDED );
				if( state != TVIS_EXPANDED ){
					treeCtrl.Expand( hItem, TVE_EXPAND );
				}
				break;
			}
			//! ̃m[h擾.
			hItem = treeCtrl.GetNextItem( hItem, TVGN_NEXT );
		}
	}
	//! m[hIԂɂ.
	if( hItem ){
		treeCtrl.SelectItem( hItem );
		SetFocus();
	}
}


/****************************************************************************/
// CFileTreeView ff
#ifdef _DEBUG
void CFileTreeView::AssertValid() const
{
	CTreeView::AssertValid();
}

#ifndef _WIN32_WCE
void CFileTreeView::Dump( CDumpContext& dc ) const
{
	CTreeView::Dump( dc );
}
#endif
#endif //_DEBUG

/* End of file */
