/****************************************************************************
 *	Copylight(C) 2018 Kanazawa-soft-design,LLC.
 ****************************************************************************/
/*!
 *	@file	MFCApp001Doc.h
 *
 *	@brief	hLgNX.
 *
 *	@author	V 閾
 */
#pragma once

class CFileTreeView;
class CFileListView;
class CFileDataView;

/****************************************************************************
 *
 * NX`.
 *
 ****************************************************************************/
/*!
 *
 *	@brief	t@C.
 *
 */
class CFileInfo
{
public:
	//! t@C.
	enum {
		TYPE_NONE = 0,				//!< s.
		TYPE_DIR,					//!< fBNg.
		TYPE_FILE					//!< t@C.
	};

public:
	CFileInfo( void ){
		m_Type     = TYPE_NONE;
		m_FileName = _T("");
		m_FileSize = _T("");
		m_FileDate = _T("");
	};

	CString&	GetFileName( void ) { return m_FileName; };
	void		SetFileName( CString& name ) { m_FileName = name; };

	CString&	GetFileSize( void ) { return m_FileSize; };
	void		SetFileSize( CString& size ) { m_FileSize = size; };

	CString&	GetFileDate( void ) { return m_FileDate; };
	void		SetFileDate( CString& date ) { m_FileDate = date; };

	int			GetType( void ) { return m_Type; };
	void		SetType( int type ) { m_Type = type; };

public:
	int			m_Type;				//!< t@C.
	CString		m_FileName;			//!< t@C.
	CString		m_FileSize;			//!< t@CTCY.
	CString		m_FileDate;			//!< t@Ct.
};

/*!
 *
 *	@brief	hLgNX.
 *
 */
class CMFCApp001Doc : public CDocument
{
protected: // VÂݍ쐬܂B
	CMFCApp001Doc();
	DECLARE_DYNCREATE(CMFCApp001Doc)

// 
public:

// 
public:

// I[o[Ch
public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
#ifdef SHARED_HANDLERS
	virtual void InitializeSearchContent();
	virtual void OnDrawThumbnail(CDC& dc, LPRECT lprcBounds);
#endif // SHARED_HANDLERS

// 
public:
	virtual ~CMFCApp001Doc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	void	UpdateFileList( CString& path );
	void	ExpandDirectory( CString& path );
	BOOL	IsFile( int idx );
	CString	GetFilePath( int idx );
	BOOL	ShowFile( CString& filename );

	int			GetFileInfoCount( void ) { return m_FileList.GetCount(); };
	CFileInfo*	GetFileInfo( int i ) { return m_FileList.GetAt( i ); };

	BYTE*		GetFileBuffer( void ) { return m_FileBuff; };
	DWORD		GetFileSize( void ) { return m_FileSize; };

protected:

// ꂽAbZ[W蓖Ċ֐
protected:
	DECLARE_MESSAGE_MAP()

#ifdef SHARED_HANDLERS
	// nh[̌Recݒ肷wp[֐
	void SetSearchContent(const CString& value);
#endif // SHARED_HANDLERS

private:
	CFileTreeView*	GetFileTreeView( void );
	CFileListView*	GetFileListView( void );
	CFileDataView*	GetFileDataView( void );

	void	CreateDriveList( void );
	void	CreateFileList( CString& path );
	void	ClearFileList( void );
	BOOL	LoadFile( CString& filename );
	CString	DigitSeparator( LONGLONG val );
	CString	ConvertFileDate( FILETIME& fileTime );

private:
	enum { MAX_FILE_SIZE = (1024 * 1024 * 10) };		//!< ǂݍރt@C̍őoCg.

	CString								m_CurrentDir;	//!< JgfBNg.
	CArray<CFileInfo *, CFileInfo *>	m_FileList;		//!< t@CXg.
	BYTE*								m_FileBuff;		//!< t@Cobt@.
	DWORD								m_FileSize;		//!< t@Cobt@̃TCY.
};

/* End of file */
