/****************************************************************************
 *	Copylight(C) 2018 Kanazawa-soft-design,LLC.
 ****************************************************************************/
/*!
 *	@file	WrapScrollBar.cpp
 *
 *	@brief	XN[o[ (MFCp).
 *
 *	@author	V 閾
 */
#include "stdafx.h"
#include "WrapScrollBar.h"

/****************************************************************************/
/*!
 *	@brief	RXgN^.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
CWrapScrollBar::CWrapScrollBar()
{
	InternalInit();
}

/****************************************************************************/
/*!
 *	@brief	fXgN^.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
CWrapScrollBar::~CWrapScrollBar()
{
}

/****************************************************************************/
/*!
 *	@brief	.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	CWrapScrollBar::InternalInit( void )
{
	m_CWnd  = NULL;
	m_Type  = SB_VERT;
	m_Pos   = 0;
	m_Max   = 0;
	m_Page  = 0;
	m_Scale = 0;
}

/****************************************************************************/
/*!
 *	@brief	XN[o[ƃEChEт.
 *
 *	@param	[in]	wnd		XN[o[\EChE.
 *	@param	[in]	type	SB_VERT=XN[o[ / SB_HORZ=XN[o[.
 *
 *	@retval	Ȃ.
 */
void	CWrapScrollBar::Bind( CWnd* wnd, int type )
{
	m_CWnd = wnd;
	m_Type = type;
}

/****************************************************************************/
/*!
 *	@brief	XN[o[ݒ肷.
 *
 *	@param	[in]	maximum	XN[o[̍ől.
 *	@param	[in]	page	XN[o[̂܂݂̕.
 *	@param	[in]	pos		XN[o[̂܂݈ʒu.
 *	@param	[in]	scale	XN[o[̍ݕ.
 *
 *	@retval	Ȃ.
 */
void	CWrapScrollBar::SetScrollBar( int maximum, int page, int pos, int scale )
{
	//! Bind()ĂяoĂȂꍇ͏Ȃ.
	if( m_CWnd == NULL ){
		return;
	}
	//! ݒlύXȂꍇ͏Ȃ.
	if(( m_Scale == scale   )
	&& ( m_Max   == maximum )
	&& ( m_Pos   == pos     )
	&& ( m_Page  == page    )){
		return;
	}
	//! XN[o[̍ݕۑ.
	m_Scale = scale;
	m_Max   = maximum;
	m_Pos   = pos;
	m_Page  = min( page, maximum );

	//! XN[o[ݒ肷.
	SCROLLINFO info;
	memset( &info, 0, sizeof(SCROLLINFO) );
	info.cbSize     = sizeof(SCROLLINFO);
	info.fMask      = SIF_POS | SIF_RANGE | SIF_PAGE | SIF_DISABLENOSCROLL;
	info.nMin       = 0;
	info.nMax       = m_Max;
	info.nPage      = m_Page;
	info.nPos       = m_Pos;
	m_CWnd->SetScrollInfo( m_Type, &info, TRUE );
}

/****************************************************************************/
/*!
 *	@brief	XN[o[̂܂݈ʒuݒ肷.
 *
 *	@param	[in]	pos		ύX̂܂݈ʒu.
 *
 *	@retval	TRUE = ܂݈ʒuύX / FALSE = ܂݈ʒuύXȂ.
 */
BOOL	CWrapScrollBar::SetScrollPos( int pos )
{
	//! Bind()ĂяoĂȂꍇ͏Ȃ.
	if( m_CWnd == NULL ){
		return FALSE;
	}
	//! XN[o[̂܂݈ʒuvZ.
	int new_pos = min( max( pos, 0 ), (m_Max - m_Page) + 1 );

	if( m_Pos != new_pos ){
		m_Pos  = new_pos;

		//! XN[o[̂܂݈ʒuݒ肷.
		SCROLLINFO info;
		memset( &info, 0, sizeof(SCROLLINFO) );
		info.cbSize = sizeof(SCROLLINFO);
		info.fMask  = SIF_POS;
		info.nPos   = m_Pos;
		m_CWnd->SetScrollInfo( m_Type, &info, TRUE );

		return TRUE;
	}
	return FALSE;
}

/****************************************************************************/
/*!
 *	@brief	XN[o[̑.
 *
 *	@param	[in]	action	XN[o[̓.
 *
 *	@retval	TRUE = ܂݈ʒuύX / FALSE = ܂݈ʒuύXȂ.
 */
BOOL	CWrapScrollBar::Action( UINT action )
{
	//! Bind()ĂяoĂȂꍇ͏Ȃ.
	if( m_CWnd == NULL ){
		return FALSE;
	}
	SCROLLINFO info;
	memset( &info, 0, sizeof(SCROLLINFO) );
	info.cbSize = sizeof( SCROLLINFO );
	info.fMask  = SIF_PAGE | SIF_POS | SIF_RANGE | SIF_TRACKPOS;

	//! ݂̃XN[o[̐ݒǂݍ.
	if( m_CWnd->GetScrollInfo( m_Type, &info ) ){

		//! XN[o[̕\ʒu肷.
		int pos;
		switch( action ){
		  case SB_TOP       : pos = info.nMin;						break;		// ŏ㕔\.
		  case SB_BOTTOM    : pos = info.nMax;						break;		// ŉ\.
		  case SB_LINEUP    : pos = info.nPos - (int)m_Scale;		break;		// ns  ɂ炷.
		  case SB_LINEDOWN  : pos = info.nPos + (int)m_Scale;		break;		// ns  ɂ炷.
		  case SB_PAGEUP    : pos = info.nPos - (int)info.nPage;	break;		// 1ʏɂ炷.
		  case SB_PAGEDOWN  : pos = info.nPos + (int)info.nPage;	break;		// 1ʉɂ炷.
		  case SB_THUMBTRACK: pos = info.nTrackPos;					break;		// ܂݈ʒuŕ\.
		  default           : pos = info.nPos;						break;
		}
		//! XN[o[̂܂݈ʒuݒ肷.
		return SetScrollPos( pos );
	}
	return FALSE;
}

/* End of file */
